diff -urpNX dontdiff linux-2.5.47/drivers/base/bus.c linux-2.5.47-pci/drivers/base/bus.c
--- linux-2.5.47/drivers/base/bus.c	2002-11-05 09:16:03.000000000 -0500
+++ linux-2.5.47-pci/drivers/base/bus.c	2002-11-16 22:42:08.000000000 -0500
@@ -13,6 +13,7 @@
 #include <linux/module.h>
 #include <linux/errno.h>
 #include <linux/init.h>
+#include <linux/string.h>
 #include "base.h"
 
 static LIST_HEAD(bus_driver_list);
diff -urpNX dontdiff linux-2.5.47/drivers/base/class.c linux-2.5.47-pci/drivers/base/class.c
--- linux-2.5.47/drivers/base/class.c	2002-11-05 09:16:03.000000000 -0500
+++ linux-2.5.47-pci/drivers/base/class.c	2002-11-16 22:42:27.000000000 -0500
@@ -5,6 +5,7 @@
 #include <linux/device.h>
 #include <linux/module.h>
 #include <linux/init.h>
+#include <linux/string.h>
 #include "base.h"
 
 static LIST_HEAD(class_list);
diff -urpNX dontdiff linux-2.5.47/drivers/base/core.c linux-2.5.47-pci/drivers/base/core.c
--- linux-2.5.47/drivers/base/core.c	2002-11-05 09:16:03.000000000 -0500
+++ linux-2.5.47-pci/drivers/base/core.c	2002-11-16 22:39:42.000000000 -0500
@@ -8,10 +8,14 @@
 #define DEBUG 0
 
 #include <linux/device.h>
-#include <linux/module.h>
-#include <linux/slab.h>
 #include <linux/err.h>
 #include <linux/init.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/string.h>
+
+#include <asm/semaphore.h>
+
 #include "base.h"
 
 LIST_HEAD(global_device_list);
diff -urpNX dontdiff linux-2.5.47/drivers/base/driver.c linux-2.5.47-pci/drivers/base/driver.c
--- linux-2.5.47/drivers/base/driver.c	2002-11-05 09:16:03.000000000 -0500
+++ linux-2.5.47-pci/drivers/base/driver.c	2002-11-16 22:42:58.000000000 -0500
@@ -8,6 +8,7 @@
 #include <linux/device.h>
 #include <linux/module.h>
 #include <linux/errno.h>
+#include <linux/string.h>
 #include "base.h"
 
 #define to_dev(node) container_of(node,struct device,driver_list)
diff -urpNX dontdiff linux-2.5.47/drivers/base/interface.c linux-2.5.47-pci/drivers/base/interface.c
--- linux-2.5.47/drivers/base/interface.c	2002-11-05 09:16:03.000000000 -0500
+++ linux-2.5.47-pci/drivers/base/interface.c	2002-11-16 22:41:00.000000000 -0500
@@ -8,6 +8,7 @@
 #include <linux/device.h>
 #include <linux/err.h>
 #include <linux/stat.h>
+#include <linux/string.h>
 
 static ssize_t device_read_name(struct device * dev, char * buf, size_t count, loff_t off)
 {
diff -urpNX dontdiff linux-2.5.47/drivers/base/intf.c linux-2.5.47-pci/drivers/base/intf.c
--- linux-2.5.47/drivers/base/intf.c	2002-11-05 09:16:03.000000000 -0500
+++ linux-2.5.47-pci/drivers/base/intf.c	2002-11-16 22:43:24.000000000 -0500
@@ -6,6 +6,7 @@
 
 #include <linux/device.h>
 #include <linux/module.h>
+#include <linux/string.h>
 #include "base.h"
 
 
diff -urpNX dontdiff linux-2.5.47/drivers/base/power.c linux-2.5.47-pci/drivers/base/power.c
--- linux-2.5.47/drivers/base/power.c	2002-10-20 10:16:01.000000000 -0400
+++ linux-2.5.47-pci/drivers/base/power.c	2002-11-16 22:41:43.000000000 -0500
@@ -12,6 +12,7 @@
 
 #include <linux/device.h>
 #include <linux/module.h>
+#include <asm/semaphore.h>
 #include "base.h"
 
 #define to_dev(node) container_of(node,struct device,g_list)
diff -urpNX dontdiff linux-2.5.47/drivers/base/sys.c linux-2.5.47-pci/drivers/base/sys.c
--- linux-2.5.47/drivers/base/sys.c	2002-11-05 09:16:03.000000000 -0500
+++ linux-2.5.47-pci/drivers/base/sys.c	2002-11-16 22:40:26.000000000 -0500
@@ -13,11 +13,12 @@
 #define DEBUG 1
 
 #include <linux/device.h>
+#include <linux/err.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/init.h>
 #include <linux/slab.h>
-#include <linux/err.h>
+#include <linux/string.h>
 
 /* The default system device parent. */
 static struct device system_bus = {
diff -urpNX dontdiff linux-2.5.47/drivers/mtd/ftl.c linux-2.5.47-pci/drivers/mtd/ftl.c
--- linux-2.5.47/drivers/mtd/ftl.c	2002-11-14 10:52:11.000000000 -0500
+++ linux-2.5.47-pci/drivers/mtd/ftl.c	2002-11-16 21:36:42.000000000 -0500
@@ -841,7 +841,7 @@ static int ftl_open(struct inode *inode,
 		return -EROFS;
 	}
     
-	DEBUG(0, "ftl_cs: ftl_open(%s)\n", inode->i_bdev->b_disk->disk_name);
+	DEBUG(0, "ftl_cs: ftl_open(%s)\n", inode->i_bdev->bd_disk->disk_name);
 
 	atomic_inc(&partition->open);
 
@@ -855,7 +855,7 @@ static release_t ftl_close(struct inode 
 	partition_t *part = inode->i_bdev->bd_disk->private_data;
 	int i;
     
-	DEBUG(0, "ftl_cs: ftl_close(%s)\n", inode->i_bdev->b_disk->disk_name);
+	DEBUG(0, "ftl_cs: ftl_close(%s)\n", inode->i_bdev->bd_disk->disk_name);
 
 	/* Wait for any pending erase operations to complete */
 	if (part->mtd->sync)
diff -urpNX dontdiff linux-2.5.47/drivers/mtd/nftlcore.c linux-2.5.47-pci/drivers/mtd/nftlcore.c
--- linux-2.5.47/drivers/mtd/nftlcore.c	2002-10-31 11:23:22.000000000 -0500
+++ linux-2.5.47-pci/drivers/mtd/nftlcore.c	2002-11-16 22:53:54.000000000 -0500
@@ -25,10 +25,7 @@
 #include <linux/init.h>
 #include <linux/blkpg.h>
 #include <linux/buffer_head.h>
-
-#ifdef CONFIG_KMOD
 #include <linux/kmod.h>
-#endif
 #include <linux/mtd/mtd.h>
 #include <linux/mtd/nftl.h>
 #include <linux/mtd/compatmac.h>
diff -urpNX dontdiff linux-2.5.47/include/linux/atmdev.h linux-2.5.47-pci/include/linux/atmdev.h
--- linux-2.5.47/include/linux/atmdev.h	2002-10-01 03:06:27.000000000 -0400
+++ linux-2.5.47-pci/include/linux/atmdev.h	2002-11-16 21:47:04.000000000 -0500
@@ -205,7 +205,7 @@ struct atm_cirange {
 #undef __AAL_STAT_ITEMS
 #else
 
-#include <linux/sched.h> /* wait_queue_head_t */
+#include <linux/wait.h> /* wait_queue_head_t */
 #include <linux/time.h> /* struct timeval */
 #include <linux/net.h>
 #include <linux/skbuff.h> /* struct sk_buff */
diff -urpNX dontdiff linux-2.5.47/include/linux/blkdev.h linux-2.5.47-pci/include/linux/blkdev.h
--- linux-2.5.47/include/linux/blkdev.h	2002-11-14 10:52:17.000000000 -0500
+++ linux-2.5.47-pci/include/linux/blkdev.h	2002-11-16 22:01:32.000000000 -0500
@@ -2,7 +2,6 @@
 #define _LINUX_BLKDEV_H
 
 #include <linux/major.h>
-#include <linux/sched.h>
 #include <linux/genhd.h>
 #include <linux/list.h>
 #include <linux/pagemap.h>
diff -urpNX dontdiff linux-2.5.47/include/linux/coda_linux.h linux-2.5.47-pci/include/linux/coda_linux.h
--- linux-2.5.47/include/linux/coda_linux.h	2002-10-15 09:32:41.000000000 -0400
+++ linux-2.5.47-pci/include/linux/coda_linux.h	2002-11-16 22:49:10.000000000 -0500
@@ -14,7 +14,6 @@
 
 #include <linux/kernel.h>
 #include <linux/param.h>
-#include <linux/sched.h> 
 #include <linux/mm.h>
 #include <linux/vmalloc.h>
 #include <linux/slab.h>
diff -urpNX dontdiff linux-2.5.47/include/linux/device.h linux-2.5.47-pci/include/linux/device.h
--- linux-2.5.47/include/linux/device.h	2002-11-05 09:16:05.000000000 -0500
+++ linux-2.5.47-pci/include/linux/device.h	2002-11-16 22:35:36.000000000 -0500
@@ -23,14 +23,16 @@
 #ifndef _DEVICE_H_
 #define _DEVICE_H_
 
-#include <linux/types.h>
 #include <linux/config.h>
 #include <linux/ioport.h>
-#include <linux/list.h>
-#include <linux/sched.h>
 #include <linux/kobject.h>
+#include <linux/list.h>
+#include <linux/spinlock.h>
+#include <linux/types.h>
+#include <asm/atomic.h>
 
-#define DEVICE_NAME_SIZE	80
+#define DEVICE_NAME_SIZE	50
+#define DEVICE_NAME_HALF	__stringify(20)	/* Less than half to accommodate slop */
 #define DEVICE_ID_SIZE		32
 #define BUS_ID_SIZE		16
 
diff -urpNX dontdiff linux-2.5.47/include/linux/elf.h linux-2.5.47-pci/include/linux/elf.h
--- linux-2.5.47/include/linux/elf.h	2002-11-14 10:52:17.000000000 -0500
+++ linux-2.5.47-pci/include/linux/elf.h	2002-11-16 22:23:32.000000000 -0500
@@ -1,7 +1,6 @@
 #ifndef _LINUX_ELF_H
 #define _LINUX_ELF_H
 
-#include <linux/sched.h>
 #include <linux/types.h>
 #include <asm/elf.h>
 
diff -urpNX dontdiff linux-2.5.47/include/linux/ftape.h linux-2.5.47-pci/include/linux/ftape.h
--- linux-2.5.47/include/linux/ftape.h	2002-10-01 03:07:12.000000000 -0400
+++ linux-2.5.47-pci/include/linux/ftape.h	2002-11-16 22:27:05.000000000 -0500
@@ -34,7 +34,7 @@
 #define KERNEL_VER(major,minor,sublvl) (((major)<<16)+((minor)<<8)+(sublvl))
 
 #ifdef __KERNEL__
-#include <linux/sched.h>
+#include <linux/interrupt.h>
 #include <linux/mm.h>
 #endif
 #include <linux/types.h>
diff -urpNX dontdiff linux-2.5.47/include/linux/i2c.h linux-2.5.47-pci/include/linux/i2c.h
--- linux-2.5.47/include/linux/i2c.h	2002-10-01 03:06:20.000000000 -0400
+++ linux-2.5.47-pci/include/linux/i2c.h	2002-11-16 22:32:14.000000000 -0500
@@ -48,7 +48,6 @@ struct i2c_msg;
 #endif
 
 #include <asm/page.h>			/* for 2.2.xx 			*/
-#include <linux/sched.h>
 #include <asm/semaphore.h>
 #include <linux/config.h>
 
diff -urpNX dontdiff linux-2.5.47/include/linux/if_pppox.h linux-2.5.47-pci/include/linux/if_pppox.h
--- linux-2.5.47/include/linux/if_pppox.h	2002-10-01 03:06:19.000000000 -0400
+++ linux-2.5.47-pci/include/linux/if_pppox.h	2002-11-16 22:38:08.000000000 -0500
@@ -24,7 +24,6 @@
 #include <linux/if_ether.h>
 #include <linux/if.h>
 #include <linux/netdevice.h>
-#include <linux/sched.h>
 #include <asm/semaphore.h>
 #include <linux/ppp_channel.h>
 #endif /* __KERNEL__ */
diff -urpNX dontdiff linux-2.5.47/include/linux/input.h linux-2.5.47-pci/include/linux/input.h
--- linux-2.5.47/include/linux/input.h	2002-10-15 09:32:41.000000000 -0400
+++ linux-2.5.47-pci/include/linux/input.h	2002-11-16 21:59:01.000000000 -0500
@@ -734,8 +734,9 @@ struct ff_effect {
  * In-kernel definitions.
  */
 
-#include <linux/sched.h>
 #include <linux/devfs_fs_kernel.h>
+#include <linux/fs.h>
+#include <linux/timer.h>
 
 #define NBITS(x) ((((x)-1)/BITS_PER_LONG)+1)
 #define BIT(x)	(1UL<<((x)%BITS_PER_LONG))
diff -urpNX dontdiff linux-2.5.47/include/linux/interrupt.h linux-2.5.47-pci/include/linux/interrupt.h
--- linux-2.5.47/include/linux/interrupt.h	2002-10-01 03:07:02.000000000 -0400
+++ linux-2.5.47-pci/include/linux/interrupt.h	2002-11-16 22:28:40.000000000 -0500
@@ -3,7 +3,6 @@
 #define _LINUX_INTERRUPT_H
 
 #include <linux/config.h>
-#include <linux/sched.h>
 #include <linux/kernel.h>
 #include <linux/smp.h>
 #include <linux/cache.h>
diff -urpNX dontdiff linux-2.5.47/include/linux/mtd/flashchip.h linux-2.5.47-pci/include/linux/mtd/flashchip.h
--- linux-2.5.47/include/linux/mtd/flashchip.h	2002-10-01 03:07:36.000000000 -0400
+++ linux-2.5.47-pci/include/linux/mtd/flashchip.h	2002-11-16 21:21:17.000000000 -0500
@@ -17,7 +17,8 @@
  * happens to be in - so we don't have to care whether we're on 2.2, which
  * has asm/spinlock.h, or 2.4, which has linux/spinlock.h 
  */
-#include <linux/sched.h>
+#include <linux/spinlock.h>
+#include <linux/wait.h>
 
 typedef enum { 
 	FL_READY,
diff -urpNX dontdiff linux-2.5.47/include/linux/mtd/nand.h linux-2.5.47-pci/include/linux/mtd/nand.h
--- linux-2.5.47/include/linux/mtd/nand.h	2002-10-01 03:07:36.000000000 -0400
+++ linux-2.5.47-pci/include/linux/mtd/nand.h	2002-11-16 21:17:45.000000000 -0500
@@ -28,7 +28,10 @@
 #define __LINUX_MTD_NAND_H
 
 #include <linux/config.h>
-#include <linux/sched.h>
+#include <linux/spinlock.h>
+#include <linux/types.h>
+#include <linux/wait.h>
+#include <linux/mtd/mtd.h>
 
 /*
  * Searches for a NAND device
diff -urpNX dontdiff linux-2.5.47/include/linux/nfsd/cache.h linux-2.5.47-pci/include/linux/nfsd/cache.h
--- linux-2.5.47/include/linux/nfsd/cache.h	2002-10-31 11:23:26.000000000 -0500
+++ linux-2.5.47-pci/include/linux/nfsd/cache.h	2002-11-16 21:42:15.000000000 -0500
@@ -11,7 +11,8 @@
 #define NFSCACHE_H
 
 #ifdef __KERNEL__
-#include <linux/sched.h>
+#include <linux/in.h>
+#include <linux/uio.h>
 
 /*
  * Representation of a reply cache entry. The first two members *must*
diff -urpNX dontdiff linux-2.5.47/include/linux/parport.h linux-2.5.47-pci/include/linux/parport.h
--- linux-2.5.47/include/linux/parport.h	2002-10-01 03:07:39.000000000 -0400
+++ linux-2.5.47-pci/include/linux/parport.h	2002-11-16 21:50:26.000000000 -0500
@@ -8,7 +8,6 @@
 
 #ifndef _PARPORT_H_
 #define _PARPORT_H_
-#include <linux/sched.h>
 
 /* Start off with user-visible constants */
 
@@ -97,13 +96,14 @@ typedef enum {
 /* The rest is for the kernel only */
 #ifdef __KERNEL__
 
-#include <linux/wait.h>
+#include <linux/config.h>
+#include <linux/jiffies.h>
+#include <linux/proc_fs.h>
 #include <linux/spinlock.h>
+#include <linux/wait.h>
 #include <asm/system.h>
 #include <asm/ptrace.h>
 #include <asm/semaphore.h>
-#include <linux/proc_fs.h>
-#include <linux/config.h>
 
 #define PARPORT_NEED_GENERIC_OPS
 
